Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_allocation.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_allocation.cpp	(revision 111)
@@ -84,4 +84,24 @@
     std::string name;
 
+    if (_param->_have_component_meta_predictor)
+    {
+      name = _name+"_meta_predictor";
+      log_printf(INFO,Prediction_unit,FUNCTION,_("Create   : %s"),name.c_str());
+      
+      _component_meta_predictor = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::Meta_Predictor
+	(name.c_str()
+#ifdef STATISTICS
+	 ,param_statistics
+#endif
+	 ,_param->_param_meta_predictor
+	 ,_usage);
+      
+      _component->set_component (_component_meta_predictor->_component
+#ifdef POSITION
+				 , 50, 50, 10, 10
+#endif
+				 );
+    }
+
     {
       name = _name+"_glue";
@@ -105,5 +125,68 @@
     // ~~~~~[ Instanciation ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
     std::string src,dest;
+
+    // ===================================================================    
+    // =====[ Meta_Predictor ]============================================    
+    // ===================================================================    
+    if (_param->_have_component_meta_predictor)
+    {
+      src = _name+"_meta_predictor";
+      log_printf(INFO,Prediction_unit,FUNCTION,_("Instance : %s"),src.c_str());
+      
+      {
+	dest = _name;
+#ifdef POSITION
+	_component->interface_map (src ,"",
+				   dest,"");
+#endif
+
+	PORT_MAP(_component,src , "in_CLOCK" ,dest, "in_CLOCK");
+	PORT_MAP(_component,src , "in_NRESET",dest, "in_NRESET");
+      }
+
+      for (uint32_t i=0; i<_param->_nb_inst_predict; i++)
+	{
+	  dest = _name+"_glue";
+#ifdef POSITION
+	  _component->interface_map (src ,"predict_"          +toString(i),
+				     dest,"predict_predictor_"+toString(i));
+#endif
+	  
+          COMPONENT_MAP(_component,src , "in_PREDICT_"+toString(i)+          "_VAL"        ,
+                                   dest,"out_PREDICT_"+toString(i)+"_PREDICTOR_VAL"        );
+          COMPONENT_MAP(_component,src ,"out_PREDICT_"+toString(i)+          "_ACK"        ,
+                                   dest, "in_PREDICT_"+toString(i)+"_PREDICTOR_ACK"        );
+          COMPONENT_MAP(_component,src , "in_PREDICT_"+toString(i)+          "_ADDRESS"    ,
+                                   dest,"out_PREDICT_"+toString(i)+"_PREDICTOR_ADDRESS_SRC");
+          COMPONENT_MAP(_component,src ,"out_PREDICT_"+toString(i)+          "_DIRECTION"  ,
+                                   dest, "in_PREDICT_"+toString(i)+"_PREDICTOR_DIRECTION"  );
+          COMPONENT_MAP(_component,src ,"out_PREDICT_"+toString(i)+          "_HISTORY"    ,
+                                   dest, "in_PREDICT_"+toString(i)+"_PREDICTOR_HISTORY"    );
+        }
+
+      for (uint32_t i=0; i<_param->_nb_inst_update; i++)
+	{
+	  dest = _name+"_glue";
+#ifdef POSITION
+	  _component->interface_map (src ,"update_"          +toString(i),
+				     dest,"update_predictor_"+toString(i));
+#endif
+	  
+          COMPONENT_MAP(_component,src , "in_UPDATE_"+toString(i)+          "_VAL"        ,
+                                   dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_VAL"        );
+          COMPONENT_MAP(_component,src ,"out_UPDATE_"+toString(i)+          "_ACK"        ,
+                                   dest, "in_UPDATE_"+toString(i)+"_PREDICTOR_ACK"        );
+          COMPONENT_MAP(_component,src , "in_UPDATE_"+toString(i)+          "_ADDRESS"    ,
+                                   dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_ADDRESS"    );
+          COMPONENT_MAP(_component,src , "in_UPDATE_"+toString(i)+          "_DIRECTION"  ,
+                                   dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_DIRECTION"  );
+          COMPONENT_MAP(_component,src , "in_UPDATE_"+toString(i)+          "_HISTORY"    ,
+                                   dest,"out_UPDATE_"+toString(i)+"_PREDICTOR_HISTORY"    );
+        }
+    }
     
+    // ===================================================================    
+    // =====[ Glue ]======================================================    
+    // ===================================================================    
     {
       src = _name+"_glue";
@@ -179,5 +262,6 @@
     }
     // ~~~~~[ Others ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
-//      _component->test_map();
+    if (DEBUG_Direction == true)
+      _component->test_map();
 
 #ifdef POSITION
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_deallocation.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_deallocation.cpp	(revision 111)
@@ -45,4 +45,6 @@
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
     delete _component_glue;
+    if (_param->_have_component_meta_predictor)
+    delete _component_meta_predictor;
     delete _component;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Parameters.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Parameters.cpp	(revision 111)
@@ -134,13 +134,31 @@
       }
 
-    _size_history = 0;
+    test();
+
+    if (_have_component_meta_predictor)
+      _param_meta_predictor = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::meta_predictor::Parameters
+        (
+         _nb_inst_predict       ,
+         _nb_inst_update        ,
+          size_address          ,
+         _have_bht              ,
+         _bht_size_shifter      ,
+         _bht_nb_shifter        ,
+         _have_pht              ,
+         _pht_size_counter      ,
+         _pht_nb_counter        ,
+         _pht_size_address_share
+         );
     
-    for (uint32_t i=0; i<3; i++)
-      _size_history += (((_have_bht [i])?_bht_size_shifter [i]:0) + 
-			((_have_pht [i])?_pht_size_counter [i]:0));
-    
-    _have_port_history = (_size_history > 0);
-
-    test();
+    _size_history = (_have_component_meta_predictor)?_param_meta_predictor->_size_history:0;
+
+    log_printf(TRACE,Direction,FUNCTION,"  * size_history : %d",_size_history);
+
+//     _size_history = 0;
+//     for (uint32_t i=0; i<3; i++)
+//       _size_history += (((_have_bht [i])?_bht_size_shifter [i]:0) + 
+// 			   ((_have_pht [i])?_pht_size_counter [i]:0));
+   
+     _have_port_history = (_size_history > 0);
 
     _param_glue = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction::direction_glue::Parameters
@@ -177,4 +195,7 @@
 
     delete _param_glue;
+    if (_have_component_meta_predictor)
+    delete _param_meta_predictor;
+
     log_printf(FUNC,Direction,FUNCTION,"End");
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Parameters_msg_error.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Parameters_msg_error.cpp	(revision 111)
@@ -39,7 +39,4 @@
       case PREDICTOR_STATIC      :
       case PREDICTOR_LAST_TAKE   : 
-	{
-	  break;
-	}
       case PREDICTOR_COUNTER     :
       case PREDICTOR_LOCAL       :
@@ -47,4 +44,8 @@
       case PREDICTOR_META        :
       case PREDICTOR_CUSTOM      :
+	{
+	  break;
+	}
+      default :
 	{
 	  test.error("Unimplemented predictor_scheme : \""+toString(_predictor_scheme)+"\". (Coming Soon)");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_predict.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_predict.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_predict.cpp	(revision 111)
@@ -254,9 +254,11 @@
                         {
                           log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"      * BRANCH_CONDITION_READ_STACK");
+                          log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"        * ras_hit : %d",PORT_READ(in_PREDICT_RAS_HIT [i]));
                           use_upt      = true;
                           use_ras      = true;
                           push         = false;
                           direction    = true;
-                          pc_next      = PORT_READ(in_PREDICT_RAS_HIT [i])?PORT_READ(in_PREDICT_RAS_ADDRESS_POP [i]):address_dest;
+                          address_dest = PORT_READ(in_PREDICT_RAS_HIT [i])?PORT_READ(in_PREDICT_RAS_ADDRESS_POP [i]):address_dest;
+                          pc_next      = address_dest;
                           branch_state = BRANCH_STATE_SPEC_TAKE;
                           is_accurate  &= (PORT_READ(in_PREDICT_RAS_HIT [i]) or btb_is_accurate); // if miss - prediction is not accurate
@@ -273,5 +275,5 @@
                     log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * direction             : %d",direction);
                     log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * branch_state          : %d",branch_state);
-                    log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * pc_next               : %.8x",pc_next);
+                    log_printf(TRACE,Prediction_unit_Glue,FUNCTION,"    * pc_next               : 0x%.8x (0x%.8x)",pc_next,pc_next<<2);
 
                     if (use_dir)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_transition.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_transition.cpp	(revision 111)
@@ -76,5 +76,8 @@
 		  if (push)
 		    {
+                      Taddress_t address = PORT_READ(in_PREDICT_ADDRESS_PUSH [i]);
+
                       log_printf(TRACE,Return_Address_Stack,FUNCTION,"    * push (call procedure)");
+                      log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * address_push        : 0x%.8x",address);
 
 		      // push : increase the top (circular)
@@ -82,5 +85,5 @@
 
                       // Write new value in Queue
-		      reg_stack [context][top_new]._address = PORT_READ(in_PREDICT_ADDRESS_PUSH [i]);
+		      reg_stack [context][top_new]._address = address;
 
 		      // Test if full
@@ -150,5 +153,8 @@
               if (push)
                 {
+                  Taddress_t address = PORT_READ(in_DECOD_ADDRESS_PUSH [i]);
+                  
                   log_printf(TRACE,Return_Address_Stack,FUNCTION,"    * push (call procedure)");
+                  log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * address_push        : 0x%.8x",address);
                   
                   // push : increase the top (circular)
@@ -156,5 +162,5 @@
                   
                   // Write new value in Queue
-                  reg_stack [context][top_new]._address = PORT_READ(in_DECOD_ADDRESS_PUSH [i]);
+                  reg_stack [context][top_new]._address = address;
                   
                   // Test if full
@@ -201,21 +207,15 @@
               //   if decod miss : ifetch can have predict call and return branchement. Also, the head of decod can be false
 
-// 	      Tcontrol_t miss       = PORT_READ(in_DECOD_MISS_PREDICTION [i]);
-
-// 	      if (miss)
-// 		{
+	      Tcontrol_t miss       = PORT_READ(in_DECOD_MISS_PREDICTION [i]);
+
+              log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * miss                : %d",miss);
+
+	      if (miss)
+		{
+
 // 		  reg_PREDICT_BOTTOM [context] = reg_BOTTOM [context];
-// 		  reg_PREDICT_TOP    [context] = reg_TOP    [context];
-// 		  reg_PREDICT_NB_ELT [context] = reg_NB_ELT [context];
-		  
-// 		  // Scan full assoc !!!
-// 		  for (uint32_t j=0; j<_param->_size_queue [context]; j++)
-// 		    // Test if this slot is tagged with "predict" : if true, tagged as miss
-// 		    if (reg_stack [context][j]._predict)
-// 		      {
-// 			reg_stack [context][j]._predict = false;
-// 			reg_stack [context][j]._miss    = true;
-// 		      }
-// 		}
+		  reg_PREDICT_TOP    [context] = reg_TOP    [context];
+		  reg_PREDICT_NB_ELT [context] = reg_NB_ELT [context];
+		}
 	    }
 
@@ -252,5 +252,10 @@
                     {
                       // reinsert push value
-                      reg_stack [context_id][0]._address = PORT_READ(in_UPDATE_ADDRESS [i]);
+                      Taddress_t address = PORT_READ(in_UPDATE_ADDRESS [i]);
+                  
+                      log_printf(TRACE,Return_Address_Stack,FUNCTION,"    * flush and push");
+                      log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * address_push        : 0x%.8x",address);
+
+                      reg_stack [context_id][value]._address = address;
                     }
                 }
@@ -292,5 +297,4 @@
 #endif
 
-
                       Tptr_t     top_old    = (prediction_ifetch)?reg_PREDICT_TOP    [context_id]:reg_TOP    [context_id];
                       Tptr_t     top_new    = top_old;
@@ -320,4 +324,6 @@
                       if (push)
                         {
+                          log_printf(TRACE,Return_Address_Stack,FUNCTION,"    * previous is push, now pop");
+
                           // previous is push, now must be pop
 
@@ -331,6 +337,10 @@
                       else
                         {
+                          log_printf(TRACE,Return_Address_Stack,FUNCTION,"    * previous is pop, now push");
+
                           // previous is pop, now must be push
                           Taddress_t address           = PORT_READ(in_UPDATE_ADDRESS           [i]);
+
+                          log_printf(TRACE,Return_Address_Stack,FUNCTION,"    * address       : 0x%.8x",address);
 
                           // push : increase the top (circular)
@@ -345,5 +355,5 @@
                           top_new = index;
                           
-                          reg_stack [context_id][index]._address = address;
+                          reg_stack [context_id][top_new]._address = address;
                         }
 
@@ -352,21 +362,33 @@
                       if (prediction_ifetch)
                         {
-                          log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_predict_top     : %d",top_new);
-//                        log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_predict_bottom  : %d",bottom_new);
-                          log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_predict_nb_elt  : %d",nb_elt_new);
-
+                          log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_predict_top     : %d",reg_TOP    [context_id]);
+//                        log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_predict_bottom  : %d",reg_BOTTOM [context_id]);
+                          log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_predict_nb_elt  : %d",reg_NB_ELT [context_id]);
+
+                          reg_PREDICT_TOP    [context_id] = reg_TOP    [context_id];
+//                        reg_PREDICT_BOTTOM [context_id] = reg_BOTTOM [context_id];
+                          reg_PREDICT_NB_ELT [context_id] = reg_NB_ELT [context_id];
+
+//                           log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_predict_top     : %d",top_new   );
+// //                        log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_predict_bottom  : %d",bottom_new);
+//                           log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_predict_nb_elt  : %d",nb_elt_new);
+
+//                           reg_PREDICT_TOP    [context_id] = top_new   ;
+// //                        reg_PREDICT_BOTTOM [context_id] = bottom_new;
+//                           reg_PREDICT_NB_ELT [context_id] = nb_elt_new;
+
+                        }
+                      else
+                        {
+                          log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_top     : %d",top_new);
+//                        log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_bottom  : %d",bottom_new);
+                          log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_nb_elt  : %d",nb_elt_new);
+
+                          reg_TOP            [context_id] = top_new   ;
+//                        reg_BOTTOM         [context_id] = bottom_new;
+                          reg_NB_ELT         [context_id] = nb_elt_new;
                           reg_PREDICT_TOP    [context_id] = top_new   ;
 //                        reg_PREDICT_BOTTOM [context_id] = bottom_new;
                           reg_PREDICT_NB_ELT [context_id] = nb_elt_new;
-                        }
-                      else
-                        {
-                          log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_top     : %d",top_new);
-//                        log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_bottom  : %d",bottom_new);
-                          log_printf(TRACE,Return_Address_Stack,FUNCTION,"      * reg_nb_elt  : %d",nb_elt_new);
-
-                          reg_TOP            [context_id] = top_new   ;
-//                        reg_BOTTOM         [context_id] = bottom_new;
-                          reg_NB_ELT         [context_id] = nb_elt_new;
                         }
                     }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/main.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/main.cpp	(revision 111)
@@ -107,4 +107,9 @@
     _ufpt_size_queue [i]                       = fromString<uint32_t    >(argv[x++]);
 
+  uint32_t     _nb_thread                           = _nb_context;
+  uint32_t *   _translate_num_context_to_num_thread = new uint32_t    [_nb_context];
+  for (uint32_t i=0; i<_nb_context; i++)
+    _translate_num_context_to_num_thread [i] = i;
+
   int _return = EXIT_SUCCESS;
   try 
@@ -135,4 +140,6 @@
 	 _upt_size_queue            ,
 	 _ufpt_size_queue           ,
+         _nb_thread                          ,
+         _translate_num_context_to_num_thread,
          true // is_toplevel
 	 );
@@ -158,4 +165,5 @@
   delete [] _upt_size_queue            ;
   delete [] _ufpt_size_queue           ;
+  delete [] _translate_num_context_to_num_thread;
 
   return (_return);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp	(revision 111)
@@ -82,7 +82,7 @@
   ALLOC1_SC_SIGNAL( in_BRANCH_COMPLETE_NO_SEQUENCE        ," in_BRANCH_COMPLETE_NO_SEQUENCE        ",Tcontrol_t         ,_param->_nb_inst_branch_complete);
   ALLOC1_SC_SIGNAL(out_BRANCH_COMPLETE_MISS_PREDICTION    ,"out_BRANCH_COMPLETE_MISS_PREDICTION    ",Tcontrol_t         ,_param->_nb_inst_branch_complete);
-  ALLOC1_SC_SIGNAL(out_BRANCH_COMPLETE_TAKE               ,"out_BRANCH_COMPLETE_TAKE               ",Tcontrol_t         ,_param->_nb_inst_branch_complete);
-  ALLOC1_SC_SIGNAL(out_BRANCH_COMPLETE_ADDRESS_SRC        ,"out_BRANCH_COMPLETE_ADDRESS_SRC        ",Taddress_t         ,_param->_nb_inst_branch_complete);
-  ALLOC1_SC_SIGNAL(out_BRANCH_COMPLETE_ADDRESS_DEST       ,"out_BRANCH_COMPLETE_ADDRESS_DEST       ",Taddress_t         ,_param->_nb_inst_branch_complete);
+//   ALLOC1_SC_SIGNAL(out_BRANCH_COMPLETE_TAKE               ,"out_BRANCH_COMPLETE_TAKE               ",Tcontrol_t         ,_param->_nb_inst_branch_complete);
+//   ALLOC1_SC_SIGNAL(out_BRANCH_COMPLETE_ADDRESS_SRC        ,"out_BRANCH_COMPLETE_ADDRESS_SRC        ",Taddress_t         ,_param->_nb_inst_branch_complete);
+//   ALLOC1_SC_SIGNAL(out_BRANCH_COMPLETE_ADDRESS_DEST       ,"out_BRANCH_COMPLETE_ADDRESS_DEST       ",Taddress_t         ,_param->_nb_inst_branch_complete);
 												                         
   ALLOC1_SC_SIGNAL(out_BRANCH_EVENT_VAL                   ,"out_BRANCH_EVENT_VAL                   ",Tcontrol_t         ,_param->_nb_context);
@@ -151,7 +151,7 @@
   INSTANCE1_SC_SIGNAL(_Prediction_unit, in_BRANCH_COMPLETE_NO_SEQUENCE        ,_param->_nb_inst_branch_complete);
   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_COMPLETE_MISS_PREDICTION    ,_param->_nb_inst_branch_complete);
-  INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_COMPLETE_TAKE               ,_param->_nb_inst_branch_complete);
-  INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_COMPLETE_ADDRESS_SRC        ,_param->_nb_inst_branch_complete);
-  INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_COMPLETE_ADDRESS_DEST       ,_param->_nb_inst_branch_complete);
+//   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_COMPLETE_TAKE               ,_param->_nb_inst_branch_complete);
+//   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_COMPLETE_ADDRESS_SRC        ,_param->_nb_inst_branch_complete);
+//   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_COMPLETE_ADDRESS_DEST       ,_param->_nb_inst_branch_complete);
 
   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_BRANCH_EVENT_VAL                   ,_param->_nb_context);
@@ -361,7 +361,7 @@
   DELETE1_SC_SIGNAL( in_BRANCH_COMPLETE_NO_SEQUENCE    ,_param->_nb_inst_branch_complete);
   DELETE1_SC_SIGNAL(out_BRANCH_COMPLETE_MISS_PREDICTION,_param->_nb_inst_branch_complete);
-  DELETE1_SC_SIGNAL(out_BRANCH_COMPLETE_TAKE           ,_param->_nb_inst_branch_complete);
-  DELETE1_SC_SIGNAL(out_BRANCH_COMPLETE_ADDRESS_SRC    ,_param->_nb_inst_branch_complete);
-  DELETE1_SC_SIGNAL(out_BRANCH_COMPLETE_ADDRESS_DEST   ,_param->_nb_inst_branch_complete);
+//   DELETE1_SC_SIGNAL(out_BRANCH_COMPLETE_TAKE           ,_param->_nb_inst_branch_complete);
+//   DELETE1_SC_SIGNAL(out_BRANCH_COMPLETE_ADDRESS_SRC    ,_param->_nb_inst_branch_complete);
+//   DELETE1_SC_SIGNAL(out_BRANCH_COMPLETE_ADDRESS_DEST   ,_param->_nb_inst_branch_complete);
 
   DELETE1_SC_SIGNAL(out_BRANCH_EVENT_VAL              ,_param->_nb_context);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/main.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/main.cpp	(revision 111)
@@ -62,4 +62,9 @@
     _size_ras_index [i] = fromString<uint32_t>(argv[x++]);
 
+  uint32_t     _nb_thread                           = _nb_context;
+  uint32_t *   _translate_num_context_to_num_thread = new uint32_t    [_nb_context];
+  for (uint32_t i=0; i<_nb_context; i++)
+    _translate_num_context_to_num_thread [i] = i;
+
   int _return = EXIT_SUCCESS;
   try 
@@ -76,4 +81,6 @@
 	 _size_history           ,
 	 _size_ras_index         ,
+         _nb_thread                          ,
+         _translate_num_context_to_num_thread,
          true //is_toplevel
          );
@@ -98,4 +105,5 @@
   delete [] _size_ufpt_queue;
   delete [] _size_upt_queue;
+  delete [] _translate_num_context_to_num_thread;
 
   return (_return);
